<?php
class ControllerExtensionTotalPrepayment extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/total/prepayment');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('total_prepayment', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			if (isset($this->request->get['apply'])) {
				$this->response->redirect($this->url->link('extension/total/prepayment', 'user_token=' . $this->session->data['user_token'] . '&type=total', true));
			} else {
        $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=total', true));
			}
		}

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}


    $data['breadcrumbs'] = array();

    $data['breadcrumbs'][] = array(
      'text'  => $this->language->get('text_home'),
      'href'  => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], true)
    );

    $data['breadcrumbs'][] = array(
      'text'  => $this->language->get('text_total'),
      'href'  => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=total', true)
    );

    $data['breadcrumbs'][] = array(
      'text'      => $this->language->get('heading_title'),
      'href'      => $this->url->link('extension/total/prepayment', 'user_token=' . $this->session->data['user_token'], true)
    );

		$data['action'] = $this->url->link('extension/total/prepayment', 'user_token=' . $this->session->data['user_token'], true);

		if (version_compare(VERSION, '2.3', '<')) {
			$data['cancel'] = $this->url->link('extension/total', 'user_token=' . $this->session->data['user_token'] . '&type=total', true);
		} else {
			$data['cancel'] = $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=total', true);
		}

		$data['apply'] = $this->url->link('extension/total/prepayment', 'user_token=' . $this->session->data['user_token'] . '&apply=1', true);

		if (isset($this->request->post['total_prepayment_type'])) {
			$data['prepayment_type'] = $this->request->post['total_prepayment_type'];
		} else {
			$data['prepayment_type'] = $this->config->get('total_prepayment_type');
		}

		if (isset($this->request->post['total_prepayment_value'])) {
			$data['prepayment_value'] = (float)$this->request->post['total_prepayment_value'];
		} else {
			$data['prepayment_value'] = (float)$this->config->get('total_prepayment_value');
		}

		if (isset($this->request->post['total_prepayment_min_value'])) {
			$data['prepayment_min_value'] = (float)$this->request->post['total_prepayment_min_value'];
		} else {
			$data['prepayment_min_value'] = (float)$this->config->get('total_prepayment_min_value');
		}

		if (isset($this->request->post['total_prepayment_min_value'])) {
			$data['prepayment_reduce_prepayment'] = (bool)$this->request->post['total_prepayment_reduce_prepayment'];
		} else {
			$data['prepayment_reduce_prepayment'] = (bool)$this->config->get('total_prepayment_reduce_prepayment');
		}

    $this->load->model('setting/extension');
		//$payments = $this->model_extension_extension->getInstalled('payment');

    //Totals
    $data['totals'] = $this->getActiveExtension('total');

		if (isset($this->request->post['total_prepayment_total'])) {
			$data['prepayment_total'] = $this->request->post['total_prepayment_total'];
		} elseif ($this->config->get('total_prepayment_total')) {
			$data['prepayment_total'] = $this->config->get('total_prepayment_total');
		} else {
      $data['prepayment_total'] = array();
    }

    //Shipping
    $data['shippings'] = $this->getActiveExtension('shipping');

		if (isset($this->request->post['total_prepayment_shipping'])) {
			$data['prepayment_shipping'] = $this->request->post['total_prepayment_shipping'];
		} else {
			$data['prepayment_shipping'] = $this->config->get('total_prepayment_shipping');
		}

		if (isset($this->request->post['total_prepayment_shipping_manual'])) {
			$data['prepayment_shipping_manual'] = $this->request->post['total_prepayment_shipping_manual'];
		} else {
			$data['prepayment_shipping_manual'] = $this->config->get('total_prepayment_shipping_manual');
		}

		//Payment
    $data['payments'] = $this->getActiveExtension('payment');

		if (isset($this->request->post['total_prepayment_payment'])) {
			$data['prepayment_payment'] = $this->request->post['total_prepayment_payment'];
		} else {
			$data['prepayment_payment'] = $this->config->get('total_prepayment_payment');
		}

		if (isset($this->request->post['total_prepayment_status'])) {
			$data['prepayment_status'] = $this->request->post['total_prepayment_status'];
		} else {
			$data['prepayment_status'] = $this->config->get('total_prepayment_status');
		}

		if (isset($this->request->post['total_prepayment_sort_order'])) {
			$data['prepayment_sort_order'] = $this->request->post['total_prepayment_sort_order'];
		} else {
			$data['prepayment_sort_order'] = !$this->config->get('total_prepayment_sort_order') ? 1 : $this->config->get('total_prepayment_sort_order');
		}

    $data['header'] = $this->load->controller('common/header');
    $data['column_left'] = $this->load->controller('common/column_left');
    $data['footer'] = $this->load->controller('common/footer');

    $this->response->setOutput($this->load->view('extension/total/prepayment', $data));

	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/total/prepayment')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!isset($this->request->post['total_prepayment_total'])) {
			$this->error['warning'] = $this->language->get('error_total');
		}

		$this->request->post['total_prepayment_shipping_manual'] = trim(str_replace(' ', '', $this->request->post['total_prepayment_shipping_manual']));

		if ((!isset($this->request->post['total_prepayment_shipping']) || empty($this->request->post['total_prepayment_shipping'])) && empty($this->request->post['total_prepayment_shipping_manual'])) {
			$this->error['warning'] = $this->language->get('error_shipping');
		}

    if (!isset($this->request->post['total_prepayment_reduce_prepayment'])) {
      $this->request->post['total_prepayment_reduce_prepayment'] = false;
    }

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

	private function getActiveExtension($type = '') {
		$actived = array();
		if ($type) {
			//Totals
			$methods = $this->model_setting_extension->getInstalled($type);
	    $files = glob(DIR_APPLICATION . 'controller/extension/' . $type . '/*.php');
	    $installed = array();
	    foreach ($files as $file) {
	    	$extension = basename($file, '.php');
	    	$key = array_search($extension, $methods);
	    	if ($key !== false) {
	    		$installed[$key] = $extension;
				}
			}

	    $sort_order = array();
	    foreach ($installed as $key => $value) {
	      $sort_order[$key] = $this->config->get($type . '_' . $value . '_sort_order');
	    }

	    array_multisort($sort_order, SORT_ASC, $installed);

	    foreach ($installed as $code) {
	      if ($this->config->get($type . '_' . $code . '_status') && $code != 'prepayment') {
	        $this->language->load('extension/' . $type . '/' . $code, 'extension');
	        $actived[] = array(
	          'code' => $code,
	          'name' => $this->language->get('extension')->get('heading_title')
	        );
	      }
	    }
		}

    return $actived;
	}
}
?>
