<?php
class ControllerExtensionTotalPrepayment extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/total/prepayment');

		if (version_compare(VERSION, '2.3', '>=')) {
			$this->prefix = 'extension/';
    }

		$data = $this->language->load($this->prefix . 'total/prepayment');

		$this->document->setTitle($this->language->get('heading_title'));
		
		// Tab
		$data['text_general'] = $this->language->get('text_general');
		$data['text_prepayment'] = $this->language->get('text_prepayment');

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('prepayment', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			if (isset($this->request->get['apply'])) {
				$this->response->redirect($this->url->link($this->prefix . 'total/prepayment', 'token=' . $this->session->data['token'] . '&type=total', true));
			} else {
				if (version_compare(VERSION, '2.3', '<')) {
	        $this->redirect($this->url->link('extension/total', 'token=' . $this->session->data['token'], 'SSL'));
	      } else {
	        $this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=total', true));
	      }
			}
		}

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

    $data['breadcrumbs'] = array();

    $data['breadcrumbs'][] = array(
      'text'  => $this->language->get('text_home'),
      'href'  => $this->url->link('common/home', 'token=' . $this->session->data['token'], true)
    );

    $data['breadcrumbs'][] = array(
      'text'  => $this->language->get('text_total'),
      'href'  => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=total', true)
    );

    $data['breadcrumbs'][] = array(
      'text'      => $this->language->get('heading_title'),
      'href'      => $this->url->link($this->prefix . 'total/prepayment', 'token=' . $this->session->data['token'], true)
    );

		$data['action'] = $this->url->link($this->prefix . 'total/prepayment', 'token=' . $this->session->data['token'], true);

		if (version_compare(VERSION, '2.3', '<')) {
			$data['cancel'] = $this->url->link('extension/total', 'token=' . $this->session->data['token'] . '&type=total', true);
		} else {
			$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=total', true);
		}

		$data['apply'] = $this->url->link($this->prefix . 'total/prepayment', 'token=' . $this->session->data['token'] . '&apply=1', true);

		if (isset($this->request->post['prepayment_type'])) {
			$data['prepayment_type'] = $this->request->post['prepayment_type'];
		} else {
			$data['prepayment_type'] = $this->config->get('prepayment_type');
		}

		if (isset($this->request->post['prepayment_value'])) {
			$data['prepayment_value'] = (float)$this->request->post['prepayment_value'];
		} else {
			$data['prepayment_value'] = (float)$this->config->get('prepayment_value');
		}

		if (isset($this->request->post['prepayment_min_value'])) {
			$data['prepayment_min_value'] = (float)$this->request->post['prepayment_min_value'];
		} else {
			$data['prepayment_min_value'] = (float)$this->config->get('prepayment_min_value');
		}

		if (isset($this->request->post['prepayment_min_value'])) {
			$data['prepayment_reduce_prepayment'] = (bool)$this->request->post['prepayment_reduce_prepayment'];
		} else {
			$data['prepayment_reduce_prepayment'] = (bool)$this->config->get('prepayment_reduce_prepayment');
		}

    $this->load->model('extension/extension');
		$payments = $this->model_extension_extension->getInstalled('payment');

    //Totals
    $data['totals'] = $this->getActiveExtension('total');

		if (isset($this->request->post['prepayment_total'])) {
			$data['prepayment_total'] = $this->request->post['prepayment_total'];
		} elseif ($this->config->get('prepayment_total')) {
			$data['prepayment_total'] = $this->config->get('prepayment_total');
		} else {
      $data['prepayment_total'] = array();
    }

    //Shipping
    $data['shippings'] = $this->getActiveExtension('shipping');

		if (isset($this->request->post['prepayment_shipping'])) {
			$data['prepayment_shipping'] = $this->request->post['prepayment_shipping'];
		} else {
			$data['prepayment_shipping'] = $this->config->get('prepayment_shipping');
		}

		if (isset($this->request->post['prepayment_shipping_manual'])) {
			$data['prepayment_shipping_manual'] = $this->request->post['prepayment_shipping_manual'];
		} else {
			$data['prepayment_shipping_manual'] = $this->config->get('prepayment_shipping_manual');
		}

		//Payment
    $data['payments'] = $this->getActiveExtension('payment');

		if (isset($this->request->post['prepayment_payment'])) {
			$data['prepayment_payment'] = $this->request->post['prepayment_payment'];
		} else {
			$data['prepayment_payment'] = $this->config->get('prepayment_payment');
		}

		if (isset($this->request->post['prepayment_status'])) {
			$data['prepayment_status'] = $this->request->post['prepayment_status'];
		} else {
			$data['prepayment_status'] = $this->config->get('prepayment_status');
		}

		if (isset($this->request->post['prepayment_sort_order'])) {
			$data['prepayment_sort_order'] = $this->request->post['prepayment_sort_order'];
		} else {
			$data['prepayment_sort_order'] = !$this->config->get('prepayment_sort_order') ? 1 : $this->config->get('prepayment_sort_order');
		}

		if (version_compare(VERSION, '2.0', '<')) {
			$this->data = $data;
			
			$this->template = 'total/prepayment.tpl';
			$this->children = array(
				'common/header',
				'common/footer'
			);

			$this->response->setOutput($this->render());
		} else {
	    $data['header'] = $this->load->controller('common/header');
	    $data['column_left'] = $this->load->controller('common/column_left');
	    $data['footer'] = $this->load->controller('common/footer');

	    $this->response->setOutput($this->load->view($this->prefix . 'total/prepayment.tpl', $data));
		}

	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', $this->prefix . 'total/prepayment')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!isset($this->request->post['prepayment_total'])) {
			$this->error['warning'] = $this->language->get('error_total');
		}

		$this->request->post['prepayment_shipping_manual'] = trim(str_replace(' ', '', $this->request->post['prepayment_shipping_manual']));

		if ((!isset($this->request->post['prepayment_shipping']) || empty($this->request->post['prepayment_shipping'])) && empty($this->request->post['prepayment_shipping_manual'])) {
			$this->error['warning'] = $this->language->get('error_shipping');
		}

    if (!isset($this->request->post['prepayment_reduce_prepayment'])) {
      $this->request->post['prepayment_reduce_prepayment'] = false;
    }

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

	private function getActiveExtension($type = '') {
		$actived = array();
		if ($type) {
			//Totals
			$methods = $this->model_extension_extension->getInstalled($type);
	    $files = glob(DIR_APPLICATION . 'controller/' . $this->prefix . $type . '/*.php');
	    $installed = array();
	    foreach ($files as $file) {
	    	$extension = basename($file, '.php');
	    	$key = array_search($extension, $methods);
	    	if ($key !== false) {
	    		$installed[$key] = $extension;
				}
			}

	    $sort_order = array();
	    foreach ($installed as $key => $value) {
	      $sort_order[$key] = $this->config->get($value . '_sort_order');
	    }
	    array_multisort($sort_order, SORT_ASC, $installed);

	    foreach ($installed as $code) {
	      if ($this->config->get($code . '_status') && $code != 'prepayment') {
	        $this->language->load($this->prefix . $type . '/' . $code);
	        $actived[] = array(
	          'code' => $code,
	          'name' => $this->language->get('heading_title')
	        );
	      }
	    }
		}

    return $actived;
	}
}
?>