<?php  //oc3.0
class ModelExtensionTotalPrepayment extends Model {
	public function getTotal($total) {
		$status = true;

		$value = $this->config->get('total_prepayment_value');

		if ($value < 0 || empty($this->session->data['shipping_method'])) {
			$status = false;
		}

		//Check Payment
		if ($status && $this->config->get('total_prepayment_payment') && !empty($this->session->data['payment_method'])) {
			$status = in_array($this->session->data['payment_method']['code'], $this->config->get('total_prepayment_payment'));
		}

		//Check shipping
		if ($status && (!empty($this->config->get('total_prepayment_shipping')) || !empty($this->config->get('total_prepayment_shipping_manual')))) {
			// First check manual shipping
			if (!empty($this->config->get('total_prepayment_shipping_manual'))) {
				$shippings = explode(';', $this->config->get('total_prepayment_shipping_manual'));
				$status = in_array($this->session->data['shipping_method']['code'], $shippings);
			}

			//check full shipping
			if (!$status && $this->config->get('total_prepayment_shipping')) {
	    	$shipping_method = explode('.', $this->session->data['shipping_method']['code']);
	    	$shipping_method = array_shift($shipping_method);
	      $shippings = $this->config->get('total_prepayment_shipping');
				$status = in_array($shipping_method, $shippings);
			}
		} else {
			$status = false;
		}

    if ($status) {
      $value = 0;
      $total_code = $this->config->get('total_prepayment_total');
      foreach ($total['totals'] as $td) {
        if (in_array($td['code'], $total_code)) {
          $value += $td['value'];
        }
      }

      if ($value > 0) {
        $prepayment = 0;
        $min_value = (float)$this->config->get('total_prepayment_min_value');
        if ($this->config->get('total_prepayment_type') == 'P') {
          $prepayment = $value * $this->config->get('total_prepayment_value')/ 100;
          if (($min_value > 0) && ($prepayment < $min_value)) {
          	if ($this->config->get('total_prepayment_reduce_prepayment')) {
							$prepayment = $min_value;
						} elseif  ($min_value > $value) {
              $prepayment = $value;
            } else {
            	$prepayment = $min_value;
						}
          }
        } else {
          $prepayment = $this->config->get('total_prepayment_value');
          if ($prepayment > $value) {
          	if ($this->config->get('total_prepayment_reduce_prepayment')) {
          		$prepayment = $min_value;
          	} else {
              $prepayment = $value;
						}
          }
        }


        $this->language->load('extension/total/prepayment');
        $total['totals'][] = array(
          'code'       => 'prepayment',
          'title'      => $this->language->get('text_total'),
          'text'       => $this->currency->format(max(0, $prepayment), $this->session->data['currency']),
          'value'      => max(0, $prepayment),
          'sort_order' => $this->config->get('total_prepayment_sort_order')
        );

        $total['total'] = max(0, $prepayment);
      }
    }
	}
}
?>
